/******************************************************************************/
/*                                                                            */
/* Procedure: IMPORTA_CLIENTE_ASSINANTE                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 08/09/2008 - Andr Rodrigo                                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE PROCEDURE IMPORTA_CLIENTE_ASSINANTE (
   P_ID_ASSINANTE  FLOAT) AS

  V_EXIST_CLIE FLOAT;

  V_IDTPIJUR   VARCHAR2(1);
  V_CDCLIENTE  VARCHAR2(21);
  V_NRINSJUR   VARCHAR2(20);
  V_EMAIL1     VARCHAR2(50);
  V_EMAIL2     VARCHAR2(50);
  V_RAZSOC     VARCHAR2(50);

  V_CNPJ_ASSINANTE               VARCHAR2(20);
  V_CPF_ASSINANTE                VARCHAR2(15);
  V_RAZAO_SOCIAL_ASSINANTE       VARCHAR2(60);
  V_NOME_ASSINANTE               VARCHAR2(30);
  V_DATA_NASC_ASSINANTE          DATE;
  V_SEXO_ASSINANTE               VARCHAR2(1);
  V_EMAIL_PESSOAL_ASSINANTE      VARCHAR2(80);
  V_EMAIL_COM_ASSINANTE          VARCHAR2(80);
  V_PAIS_ASSINANTE               VARCHAR2(4);
  V_ESTADO_ASSINANTE             VARCHAR2(2);
  V_CIDADE_ASSINANTE             VARCHAR2(4);
  V_ENDERECO_ASSINANTE           VARCHAR2(40);
  V_COMPLEMENTO_ENDER_ASSINANTE  VARCHAR2(20);
  V_BAIRRO_ASSINANTE             VARCHAR2(40);
  V_TEL_COM1_ASSINANTE           VARCHAR2(15);
  V_TEL_COM2_ASSINANTE           VARCHAR2(15);
  V_TEL_RES_ASSINANTE            VARCHAR2(15);
  V_TEL_CEL_ASSINANTE            VARCHAR2(15);
  V_CEP_ASSINANTE                VARCHAR2(11);
  V_CLIE_ASSINANTE               VARCHAR2(21);
BEGIN
   SELECT
      CNPJ_ASSINANTE, CPF_ASSINANTE, RAZAO_SOCIAL_ASSINANTE, NOME_ASSINANTE,
      DATA_NASC_ASSINANTE, SEXO_ASSINANTE, EMAIL_PESSOAL_ASSINANTE, EMAIL_COM_ASSINANTE,
      CDPAIS, SGESTADO, CDMUNICIPIO, ENDERECO_ASSINANTE,
      COMPLEMENTO_ENDER_ASSINANTE, BAIRRO_ASSINANTE, TEL_COM2_ASSINANTE, CDCLIENTE
   INTO
      V_CNPJ_ASSINANTE, V_CPF_ASSINANTE, V_RAZAO_SOCIAL_ASSINANTE, V_NOME_ASSINANTE,
      V_DATA_NASC_ASSINANTE, V_SEXO_ASSINANTE, V_EMAIL_PESSOAL_ASSINANTE, V_EMAIL_COM_ASSINANTE,
      V_PAIS_ASSINANTE, V_ESTADO_ASSINANTE, V_CIDADE_ASSINANTE, V_ENDERECO_ASSINANTE,
      V_COMPLEMENTO_ENDER_ASSINANTE, V_BAIRRO_ASSINANTE, V_TEL_COM2_ASSINANTE, V_CLIE_ASSINANTE
   FROM USR_ASSINANTES
   WHERE ID_ASSINANTE = P_ID_ASSINANTE;

   IF NOT V_CNPJ_ASSINANTE IS NULL THEN
      V_IDTPIJUR  := 'J';
      V_NRINSJUR  := V_CNPJ_ASSINANTE;
   ELSE
      V_IDTPIJUR  := 'F';
      V_NRINSJUR  := V_CPF_ASSINANTE;
   END IF;

   V_CDCLIENTE := V_IDTPIJUR || V_NRINSJUR;

   IF V_RAZAO_SOCIAL_ASSINANTE IS NULL THEN
      V_RAZSOC := V_NOME_ASSINANTE;
   ELSE
      V_RAZSOC := V_RAZAO_SOCIAL_ASSINANTE;
   END IF;

   SELECT COUNT(CDCLIENTE)
   INTO V_EXIST_CLIE
   FROM CLIENTE
   WHERE CDCLIENTE = V_CDCLIENTE;

   IF V_EXIST_CLIE = 0 THEN

      INSERT INTO CLIENTE
         (CDCLIENTE,  IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE,
          DTCADACLIE, DTNASCCLIE,   IDSEXOCLIE)
      VALUES
         (V_CDCLIENTE, V_IDTPIJUR, V_NRINSJUR, V_RAZSOC, V_NOME_ASSINANTE,
          SYSDATE, V_DATA_NASC_ASSINANTE, V_SEXO_ASSINANTE);

      V_EMAIL1 := '';
      V_EMAIL2 := '';
      IF NOT V_EMAIL_PESSOAL_ASSINANTE IS NULL THEN
         V_EMAIL1 := SUBSTR(V_EMAIL_PESSOAL_ASSINANTE, 1, 50);
      END IF;
      IF NOT V_EMAIL_COM_ASSINANTE IS NULL THEN
         V_EMAIL2 := SUBSTR(V_EMAIL_COM_ASSINANTE, 1, 50);
      END IF;

      INSERT INTO ENDECLIE
         (CDCLIENTE,    IDTPENDECLIE, CDPAIS,     SGESTADO,  CDMUNICIPIO,
          DSENDECLIE,   DSCOMPENDCLI, NMBAIRCLIE, NRCEPCLIE,
          NRTELRESICLI, NRCELULARCLI, NRTELECLIE, NRTELECLIE1,
          DSEMAILCLIE,  DSEMAILCLIE2)
      VALUES
         (V_CDCLIENTE, 'P', V_PAIS_ASSINANTE, V_ESTADO_ASSINANTE, V_CIDADE_ASSINANTE,
          V_ENDERECO_ASSINANTE, V_COMPLEMENTO_ENDER_ASSINANTE, V_BAIRRO_ASSINANTE, V_CEP_ASSINANTE,
          V_TEL_RES_ASSINANTE, V_TEL_CEL_ASSINANTE, V_TEL_COM1_ASSINANTE, V_TEL_COM2_ASSINANTE,
          V_EMAIL1, V_EMAIL2);

      UPDATE USR_ASSINANTES
      SET CDCLIENTE = V_CDCLIENTE
      WHERE ID_ASSINANTE = P_ID_ASSINANTE;
   ELSE

      UPDATE CLIENTE
      SET NMRAZSOCCLIE = V_RAZSOC,
          NMFANTCLIE = V_NOME_ASSINANTE,
          DTNASCCLIE = V_DATA_NASC_ASSINANTE,
          IDSEXOCLIE = V_SEXO_ASSINANTE
      WHERE CDCLIENTE = V_CDCLIENTE;

      IF NOT V_EMAIL_PESSOAL_ASSINANTE IS NULL THEN
         V_EMAIL1 := SUBSTR(V_EMAIL_PESSOAL_ASSINANTE, 1, 50);
      END IF;
      IF NOT V_EMAIL_COM_ASSINANTE IS NULL THEN
         V_EMAIL2 := SUBSTR(V_EMAIL_COM_ASSINANTE, 1, 50);
      END IF;

      UPDATE ENDECLIE
      SET CDPAIS        = V_PAIS_ASSINANTE,
          SGESTADO      = V_ESTADO_ASSINANTE,
          CDMUNICIPIO   = V_CIDADE_ASSINANTE,
          DSENDECLIE    = V_ENDERECO_ASSINANTE,
          DSCOMPENDCLI  = V_COMPLEMENTO_ENDER_ASSINANTE,
          NMBAIRCLIE    = V_BAIRRO_ASSINANTE,
          NRCEPCLIE     = V_CEP_ASSINANTE,
          NRTELRESICLI  = V_TEL_RES_ASSINANTE,
          NRCELULARCLI  = V_TEL_CEL_ASSINANTE,
          NRTELECLIE    = V_TEL_COM1_ASSINANTE,
          NRTELECLIE1   = V_TEL_COM2_ASSINANTE,
          DSEMAILCLIE   = V_EMAIL1,
          DSEMAILCLIE2  = V_EMAIL2
      WHERE CDCLIENTE = V_CDCLIENTE
        AND IDTPENDECLIE = 'P';
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_CLIENTE_ASSINANTE','5.07.001'); END;
/

