/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_REFEBIBL                                                 */
/* Tabela : REFEBIBL                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_REFEBIBL'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_REFEBIBL
  GO


CREATE TRIGGER DTULTATU_REFEBIBL
ON REFEBIBL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'REFEBIBL', NULL, 'CDREFEBIBL='+CDREFEBIBL+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE REFEBIBL
      SET DTULTATUREBI = GETDATE()
      FROM INSERTED
      WHERE
         (REFEBIBL.CDREFEBIBL = INSERTED.CDREFEBIBL)
   END
END;
GO



